OSPF Extensions for BIER-TE
Huaimo Chen
Futurewei
Boston, MA
USA
Huaimo.chen@futurewei.com
Mike McBride
Futurewei
michael.mcbride@futurewei.com
Aijun Wang
China Telecom
Beiqijia Town, Changping District
Beijing
102209
China
wangaj3@chinatelecom.cn
Gyan S. Mishra
Verizon Inc.
13101 Columbia Pike
Silver Spring
MD 20904
USA
301 502-1347
gyan.s.mishra@verizon.com
Yanhe Fan
Casa Systems
USA
yfan@casa-systems.com
Lei Liu
Fujitsu
USA
liulei.kddi@gmail.com
Xufeng Liu
IBM Corporation
USA
xufeng.liu.ietf@gmail.com
2022
This document describes OSPF extensions for distributing BitPositions configured on the links in "Bit Index Explicit Replication Traffic Engineering" (BIER-TE) domain.

Requirements Language
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in [RFC2119] [RFC8174] when, and only when, they appear in all capitals, as shown here.

Introduction
[I-D.ietf-bier-te-arch] introduces Bit Index Explicit Replication (BIER) Traffic/Tree Engineering (BIER-TE). It is an architecture for per-packet stateless explicit point to multipoint (P2MP) multicast path/tree.
A link in a BIER-TE domain has its BitPositions. For a link between two nodes X and Y, there are two BitPositions for two forward connected adjacencies. These two adjacency BitPositions could be configured on nodes X and Y respectively. The BitPosition configured on X is the forward connected adjacency of Y. The BitPosition configured on Y is the forward connected adjacency of X.
This document proposes OSPF extensions for distributing BitPositions configured on the links in "Bit Index Explicit Replication Traffic Engineering" (BIER-TE) domain.

Terminology
BIER: Bit Index Explicit Replication.
BIER-TE: BIER Traffic Engineering.
BFR: Bit-Forwarding Router.
BFIR: Bit-Forwarding Ingress Router.
BFER: Bit-Forwarding Egress Router.
BFR-id: BFR Identifier. It is a number in the range [1,65535].
BFR-NBR: BFR Neighbor.
LSA: Link State Advertisement.
OSPF: Open Shortest Path First.

Extensions to OSPFv2
This section describes protocol extensions to OSPFv2 for distributing BIER-TE information such as the BitPositions configured on the links in a BIER-TE domain.
[RFC7684] defines the OSPFv2 Extended Link TLV to advertise the information about a link. Multiple Link TLVs for the links of a router are included in the OSPFv2 Extended Link Opaque LSA of the router.
The OSPFv2 Extended Link TLV has the following format:

OSPFv2 Extended Link TLV

    0                   1                   2                   3
    0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
   |            Type (1)           |      Length (Variable)        |
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
   |   Link Type   |                    Reserved                   |
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
   |                             Link ID                           |
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
   |                            Link Data                          |
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
   |                       Sub-TLVs (variable)                     |
   ~                                                               ~
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
Type: 1.
Length: Variable, dependent on Sub-TLVs.
Link Type, Link ID and Link Data: They are defined in Section A.4.2 of [RFC2328].
Reserved: MUST be set to 0 on transmission and MUST be ignored on reception.
Under the OSPFv2 Extended Link TLV for a link, a Sub-TLV, called BIER-TE Sub-TLV, is defined for distributing BIER-TE information about the link. A BIER-TE Sub-TLV is included in the Link TLV for a link of Link Type Point-to-Point or Broadcast (or say LAN or Transit Network).
The BIER-TE Sub-TLV has the following format:

BIER-TE Sub-TLV

    0                   1                   2                   3
    0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
   |          Type (TBD1)          |             Length            |
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
   | sub-domain-id |     MT-ID     |      BAR      |    IPA        |
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
   |         BitPosition           |         DrEndBitPosition      |
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
Type: TBD1 is to be assigned by IANA.
Length: Variable.
sub-domain-id: Unique value identifying a BIER-TE sub-domain.
MT-ID: Multi-Topology ID identifying the topology that is associated with the BIER-TE sub-domain.
BAR: Single-octet BIER Algorithm used to calculate underlay paths to reach other BFRs. Values are allocated from the "BIER Algorithm" registry defined in [RFC8401].
IPA: Single-octet IGP Algorithm used to either modify, enhance, or replace the calculation of underlay paths to reach other BFRs as defined by the BAR value. Values are defined in the "IGP Algorithm Types" registry.
BitPosition: A 2-octet field encoding the BitPosition locally configured on the link/interface when the Link Type of the link in the OSPFv2 Extended Link TLV containing this Sub-TLV is 1 (i.e., Point-to-Point connection to another router) or 2 (i.e., connection to Transit Network or say LAN).
DrEndBitPosition: A 2-octet field encoding the BitPosition of the connection on the designated router (DR) end. This field is valid when the Link Type in the OSPFv2 Extended Link TLV containing this Sub-TLV is 2 (i.e., Transit Network or LAN). For the other value of the Link Type, this field MUST be ignored. The DrEndBitPosition may be configured on the link/interface to a transit network (i.e., broadcast link or say LAN).
Note that if each of BitPosition and DrEndBitPosition uses more than 2 octets, we use 4 or more octets for each of them.

Security Considerations
TBD.

IANA Considerations
Under "OSPFv2 Extended Link TLV Sub-TLVs registry" as defined in [RFC7684], IANA is requested to assign a new registry value for BIER-TE Sub-TLV as follows:

  +==============+===================+=====================+
  |  Value       |  Description      |    reference        |
  +==============+===================+=====================+
  |  TBD1 (25)   |  BIER-TE          |    This document    |
  +--------------+-------------------+---------------------+

Acknowledgements
The authors would like to thank Acee Lindem and Tony Przygienda for their comments on this work.

Normative References

Informative References
[RFC2119]
[RFC8174]
[I-D.ietf-bier-te-arch]
[RFC7684]
[RFC2328]
[RFC8401]